/*
 * Programa desenvolvido por Anderson Zanardi de Freitas
 * MAC5768 - 2003
 * Verso 2
 */

/* Importa pacotes especficos
 * awt = abstract windows toolkit
 * event = tratamento de eventos
 * swing = janelas e ambiente grfico
 * image = manipulao de imagems
 * io = entrada e saida de dados
 */
 
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.*;
import java.io.*;

/*
 * Definio da classe principal mac5768_ep que  uma exteno da classe JFrame
 * implementa a interface ActionListener, para tratamente de eventos
 */
public class mac5768_ep extends JFrame implements ActionListener{

/*
 * Objetos paa construo dos menus e botes
 */
	JMenuItem 	abrirItem, sairItem,
				cinzaItem, planosItem, equalizaItem, especificaItem,
				mascara3x3Item, mascara5x5Item, mascara7x7Item, mascara9x9Item,
				mascaraXxXItem;

	JButton btnCinza, btnPlanos, btnHistogram, btnMascaraOk;
	
	JFileChooser arquivoEscolhido = new JFileChooser();
	Image img;
	JPanel pane;
	myJFrame mf;
	int[][] vetor; 	/*Vetor  a varivel onde so armazenados os valores dos nveis
					de cinza da imagem*/
	
	MemoryImage memimg;

/*
 * Implementao do mtodo construtor onde  criada a tela principal
 */	    
    public mac5768_ep() {
        super("mac5768_ep");

		JMenuBar bar = new JMenuBar(); //cria barra de menu
		setJMenuBar(bar);
		
		JMenu arquivoMenu = new JMenu("Arquivo");
		arquivoMenu.setMnemonic('A');
		
		abrirItem = new JMenuItem("Abrir...");
		abrirItem.setMnemonic('a');
		sairItem = new JMenuItem("Sair");
		sairItem.setMnemonic('r');

		arquivoMenu.add(abrirItem);
		arquivoMenu.add(sairItem);
		
		JMenu ferramentasMenu = new JMenu("Ferramentas");
		ferramentasMenu.setMnemonic('F');
		cinzaItem = new JMenuItem("Nveis de cinza");
		cinzaItem.setMnemonic('N');
		planosItem = new JMenuItem("Planos de Bits...");
		planosItem.setMnemonic('P');

		JMenu histogramaMenu = new JMenu("Histograma...");
		histogramaMenu.setMnemonic('H');
		equalizaItem = new JMenuItem("Equalizao de Histograma");
		equalizaItem.setMnemonic('E');
		especificaItem = new JMenuItem("Especificao de Histograma...");
		especificaItem.setMnemonic('p');
		histogramaMenu.add(equalizaItem);
		histogramaMenu.add(especificaItem);

		JMenu mascaraMenu = new JMenu("Mscaras...");
		mascara3x3Item = new JMenuItem("Mascara 3x3");
		mascara3x3Item.setMnemonic('3');
		mascara5x5Item = new JMenuItem("Mascara 5x5");
		mascara5x5Item.setMnemonic('5');
		mascara7x7Item = new JMenuItem("Mascara 7x7");
		mascara7x7Item.setMnemonic('7');
		mascara9x9Item = new JMenuItem("Mascara 9x9");
		mascara9x9Item.setMnemonic('9');
		mascaraXxXItem = new JMenuItem("Mascara XxX");
		mascaraXxXItem.setMnemonic('X');
		mascaraMenu.add(mascara3x3Item);
		mascaraMenu.add(mascara5x5Item);
		mascaraMenu.add(mascara7x7Item);
		mascaraMenu.add(mascara9x9Item);
		mascaraMenu.add(mascaraXxXItem);
				
		ferramentasMenu.add(cinzaItem);
		ferramentasMenu.add(planosItem);
		ferramentasMenu.add(histogramaMenu);
		ferramentasMenu.add(mascaraMenu);
		
		bar.add(arquivoMenu);
		bar.add(ferramentasMenu);
		
		ImageIcon imgCinza = new ImageIcon("icons/cinza.png");
		btnCinza = new JButton(imgCinza);
		ImageIcon imgPlanos = new ImageIcon("icons/planos.png");
		btnPlanos = new JButton(imgPlanos);
		ImageIcon imgHistogram = new ImageIcon("icons/histogram.png");
		btnHistogram = new JButton(imgHistogram);
        
        btnCinza.addActionListener(this);
        btnPlanos.addActionListener(this);
        btnHistogram.addActionListener(this);
        abrirItem.addActionListener(this);
        sairItem.addActionListener(this);
        cinzaItem.addActionListener(this);
        planosItem.addActionListener(this);
        equalizaItem.addActionListener(this);
        especificaItem.addActionListener(this);

		mascara3x3Item.addActionListener(this);
		mascara5x5Item.addActionListener(this);
		mascara7x7Item.addActionListener(this);
		mascara9x9Item.addActionListener(this);
		mascaraXxXItem.addActionListener(this);
		mascaraMenu.addActionListener(this);
	
        Image img = Toolkit.getDefaultToolkit().getImage("inicial.jpg");
		mf = new myJFrame(img);
		mf.setSize(600,400);
		mf.setVisible(true);

		pane = new JPanel();
		pane.add(btnCinza);
       	pane.add(btnPlanos);
       	pane.add(btnHistogram);
       	setContentPane(pane);
       	
       	/*
       	 * Metodo para tratamento do evento de fechar a janela
       	 */
        addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				dispose();
				System.exit(0);
			} //windowClosing
		}); //addWindowListener 	
	} //Album construtor
	
	
	byte [][][] planoBinario; //definio da vetor tridimensional para os dados dos planso binrios 
	boolean planos = false; 
/*
 * Mtodo extraiBits(): mtodo para percorrer todo os pixeis da imagem.
 */	
	void extraiBits(){
	planoBinario = new byte[8][dimY][dimX];
	for(int j=0; j<dimY; j++)  //lao para percorrer todos os pixels da imagem
		for(int i=0; i<dimX; i++)
			extraiBit(i,j);
	} //extraiBits

/*
 * Mtodo extraiBit(int x, int y): converte um dado byte (nvel de cinza) para
 * os  8 correspondentes planos binrios.
 */
	void extraiBit(int x, int y){
	int n = vetor[y][x]; //nmero a ser verificado
	for(int i=7;i>=0;i--){  //lao para a ferificao de cado bit
        if(n>(Math.pow(2,i)-1)){
            planoBinario[i][y][x]=1;  //armazena bit 1 no plano i do ponto (x,y)
            n=n-(int)Math.pow(2,i);  //desloca para o prximo bit
        } //if
        else
            planoBinario[i][y][x]=0;  //armazena bit 0 no plano i do ponto (x,y)
    } //for
} //extraiBit		
	 
/*
 * Mtodo abrir(): utilizado para ler uma figura do arquivo.
 */
	public void abrir(){
		arquivoEscolhido.setDialogTitle("Escolha um arquivo");
		int returnVal = arquivoEscolhido.showOpenDialog(mac5768_ep.this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = arquivoEscolhido.getSelectedFile();
			img = Toolkit.getDefaultToolkit().getImage(file.getPath());
			mf.changeImage(img); //atualiza a imagem na janela ativa
			mf.setVisible(true);
		}
	} //abrir	
	
	int dimX, dimY; //variveis com as dimenes da imagem
	
/*
 * Mdoto retornaData(Image img): recebe ima imagem como parmentro e retorna
 * a varivel "vetor" com os nveis de cinza da imagem.
 */	
	public void retornaData(Image img){
		memimg = new MemoryImage(img);
		memimg.waitForImage(); //espera a t que a imagem seja carregada
		dimX = memimg.dimencionX(); //largura da imagem em pixeis
		dimY = memimg.dimencionY(); //altura da imagem em pixeis
	 	vetor = new int[dimY][dimX]; //instanciao do vetor
	 	vetor=memimg.imgPixelsData(); //retorno de valores para a varivel vetor
	} //retorna Data
	
/*
 * Mtodo niveisCinza(Image imgCinza): mtodo para conveter qualquer imagem do 
 * sistema RGB, para imagem RGB em nveis de cinza
 */
	public void niveisCinza(Image imgCinza){
		retornaData(imgCinza);
		int x = dimX;
		int y = dimY;
		int[] vetorLinha = new int[x*y];
		int cont=0;
		for(int j=0;j<y;j++)
			for(int i=0;i<x;i++){
				//retorna a componente vermelho, azul e verde do pixel (i,j)
				int red = (new Color(vetor[j][i]).getRed())&0xff; 
				int blue = (new Color(vetor[j][i]).getBlue())&0xff;
				int green = (new Color(vetor[j][i]).getGreen())&0xff;
				int media = Math.round((red+blue+green)/3);
				vetor[j][i] = media; //255 nveis de cinza
				vetorLinha[cont++] = (255<<24)|(media<<16)|(media<<8)|media;
			} //deslocamento de bits devido  representao em alfa-RBG do java
		imgCinza = createImage(new MemoryImageSource(x,y,vetorLinha,0,x));
		mf.changeImage(imgCinza); //atualiza a imagem na janela ativa
	} //nveisCinza	

/*
 * Mtodo constroiImageVetor(int [][] vetorImagem): recebe um vetor com nveis
 * de cinza para cada pixel (i,j), constroi um vetor unidimensional para exibir 
 * a imagem.
 */
	public void constroiImageVetor(int [][] vetorImagem){	
		int x = dimX;
		int y = dimY;
		int[] vetorLinha = new int[x*y];
		int cont=0;
		for(int j=0;j<y;j++)
			for(int i=0;i<x;i++){
				int media = vetorImagem[j][i];
				vetorLinha[cont++] = (255<<24)|(media<<16)|(media<<8)|media;
			}
		Image imgConstruida = createImage(new MemoryImageSource(x,y,vetorLinha,0,x));
		mf = new myJFrame(imgConstruida);
		mf.setVisible(true);
	} //retornaData

/*
 * Mtodo histograma(int[][] vetorHist): faz a equalizao de histograma da imagem
 * de entrada. 
 */	
	public void histograma(int[][] vetorHist){
		int[] niveisCinzaIn = new int[256];
		int[][] vetorHist2 = new int[dimY][dimX];
		vetorHist2 = vetorHist; 
		// lao para contruir o histograma da imagem de entrada
		int k = 0;
		for(int j=0; j<dimX; j++)
			for(int i=0; i<dimY; i++){
				do{
					if(vetorHist2[i][j]==k) niveisCinzaIn[k]++;
					k++;
				}while((vetorHist2[i][j]!=(k-1))&&(k<256));
				k = 0;
			}
		//construo de transformada s, como descrito no texto	
		float[] niveisCinzaOut = new float[256]; 	
		float max=0;
		for(int j=0; j<256; j++){
			for(int i=0; i<=j; i++)			
				niveisCinzaOut[j]+=niveisCinzaIn[i];
			niveisCinzaOut[j]/=(dimX*dimY);
			//encontra a valor mximo para normalizao
			if(niveisCinzaOut[j]>=max) max=niveisCinzaOut[j];
			}
		for(int i=0; i<256; i++)
			niveisCinzaOut[i]=(niveisCinzaOut[i]/max)*255; 				
		for(int j=0; j<dimX; j++)
			for(int i=0; i<dimY; i++){
				//construo do vetor na imagem de sada
				vetorHist2[i][j]=(int)(niveisCinzaOut[vetorHist[i][j]]); 
			}
		constroiImageVetor(vetorHist2);
	} //histograma	
	
	/*
	 * Medodo actionPerformed(ActionEvent e): tratamento dos evento do 
	 * mouse e dos menus
	 */
	public void actionPerformed (ActionEvent e) {
		if(e.getSource() == abrirItem){abrir();}
		if(e.getSource() == sairItem){
			int resposta = JOptionPane.showConfirmDialog(null,"Deseja sair","mac5768_ep",
													JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);
			if(resposta == JOptionPane.YES_OPTION){
				dispose();
				System.exit(0);
			}	
		}
		if((e.getSource() == cinzaItem)||(e.getSource()==btnCinza)){
			niveisCinza(img);
		}
		if((e.getSource() == planosItem)||(e.getSource()==btnPlanos)){
			
				String resposta = JOptionPane.showInputDialog(null,"Digite	o nmero do plano de bits: 0-7");
			if(resposta != null){
				if(!planos){
					extraiBits();
					planos = true;
				}	
				int planobit = Integer.parseInt(resposta);
				int[][] planoVetor = new int[dimY][dimX];
				for(int j=0; j<dimX; j++)  //lao para percorrer todos os pixels da imagem
						for(int i=0; i<dimY; i++){
							planoVetor[i][j] = planoBinario[planobit][i][j]*255;
						}	
				constroiImageVetor(planoVetor);
				
			}												
		}
		if((e.getSource() == equalizaItem)||(e.getSource()==btnHistogram)){histograma(vetor);}
		if((e.getSource() == mascara3x3Item)){
			mascaraFrame = new MascaraJFrame(3,3);
		}
		if((e.getSource() == mascaraFrame.btnMascaraOk)){
			System.out.println("tetetetet");//constroiMascara();
		}	
	 } //actionPerformed
	 
	 MascaraJFrame mascaraFrame;
	 
/*
 * Mtodo principal
 */	
    public static void main(String[] args) {
        JFrame frame = new mac5768_ep();
        frame.pack();
        frame.setVisible(true);
    } //main
} //mac5768_ep

/*
 * Classe myJFrame: para exibio das janelas grficas
 */
class myJFrame extends JFrame{
  Image saved_i;
  int iWidth, iHeight;

/*
 * Mtodo construtor
 */  
	public myJFrame(Image i){
    	saved_i=i;
    	iWidth = saved_i.getWidth(this);
    	iHeight = saved_i.getHeight(this);
    	this.resize(iWidth,iHeight);
  	} //myCanvasw construtor
  
	public void changeImage(Image i){
    	saved_i = i;
    	repaint();
  	}
  	public void paint(Graphics g){
  		int width = this.getWidth();
		int height = this.getHeight();
    	g.drawImage(saved_i, 0, 0, width, height, this);
  	} //paint
} //myJFrame

/*
 * Classe mascaraJFrame: para exibio das janelas de mcaras
 */
class MascaraJFrame extends JFrame{
	JFrame MascaraFrame = new JFrame();
  	JPanel panel = new JPanel();
  	JPanel panelMatriz = new JPanel();
  	JTextField[] txtFieldObjeto;
  	JButton btnMascaraOk = new JButton("Ok");
  	int x, y;
  	int[][] mascara;
/*
 * Mtodo construtor
 */  
	public MascaraJFrame(int x, int y){
		txtFieldObjeto = new JTextField[x*y];
		panel.setLayout(new BorderLayout());
		panelMatriz.setLayout(new GridLayout(x,y));
		mascara = new int[x][y];
		for(int i=0; i<(x*y); i++){
			txtFieldObjeto[i] = new JTextField(2);
			txtFieldObjeto[i].setHorizontalAlignment(JTextField.CENTER);
			panelMatriz.add(txtFieldObjeto[i]);
		}

		panel.add(panelMatriz,BorderLayout.CENTER);
		panel.add(btnMascaraOk,BorderLayout.SOUTH);	
		MascaraFrame.setContentPane(panel);
		MascaraFrame.pack();
		MascaraFrame.setVisible(true);	
  	} //mascaraJFrame construtor
  	
  	public int[][] getMascara(){
  		for(int j=0; j<y; j++){
  			for(int i=0; i<x; i++)
				mascara[i][j] = Integer.parseInt(txtFieldObjeto[i].getText());
		}
		return mascara;		
  	} //getMascara
  	
} //mascaraJFrame

/*
 * Classe MemoryImage: que implementa a interface ImageConsumer (padro do Java)
 */
class MemoryImage implements ImageConsumer {
    int imgxsize, imgysize;
    int imgpixels[][];

    MemoryImage(Image picture) {
        picture.getSource().startProduction(this);
    }
    synchronized void waitForImage() {
	try{ wait();} catch (Exception e){};
    }
    public void setProperties(java.util.Hashtable dummy) {
    }
    public void setColorModel(ColorModel dummy) {
    }
    public void setHints(int dummy) {
    }
    public synchronized void imageComplete(int dummy) {
        notifyAll();
    }
    public void setDimensions(int x, int y) {
        imgxsize = x;
        imgysize = y;
        imgpixels = new int[y][x]; 
    }
    int dimencionX(){
    	return imgxsize;
    }	
    int dimencionY(){
    	return imgysize;
    }	
	int[][] imgPixelsData(){
		return imgpixels;	
	}	
    public void setPixels(int x1, int y1, int w, int h, 
        ColorModel model, byte pixels[], int off, int scansize) {
        int pix, x, y, x2, y2, sx, sy;

        x2 = x1+w;
        y2 = y1+h;
        sy = off;
        for(y=y1; y<y2; y++) {
            sx = sy;
            for(x=x1; x<x2; x++) {
                pix = model.getRGB(pixels[sx++]);
                if((pix & 0xff000000) == 0)
                    pix = 0x00ffffff;
                imgpixels[y][x] = pix;
            }
            sy += scansize;
        }
    } //setPixels
    public void setPixels(int x1, int y1, int w, int h, 
        ColorModel model, int pixels[], int off, int scansize) {
        int pix, x, y, x2, y2, sx, sy;
        x2 = x1+w;
        y2 = y1+h;
        sy = off;
        for(y=y1; y<y2; y++) {
            sx = sy;
            for(x=x1; x<x2; x++) {
                pix = model.getRGB(pixels[sx++]);
                if((pix & 0xff000000) == 0)
                    pix = 0x00ffffff;
                imgpixels[y][x] = pix;
            }
            sy += scansize;
        }
    } //setPixels
} //MemoryImage